{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.DerivativeGenerator
       (
         DerivativeGenerator,
         DerivativeGeneratorClass(..),
         derivativeGenerator,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show DerivativeGenerator where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__DerivativeGenerator__DerivativeGenerator" c_CasADi__DerivativeGenerator__DerivativeGenerator
  :: IO (Ptr DerivativeGenerator')
casADi__DerivativeGenerator__DerivativeGenerator
  :: IO DerivativeGenerator
casADi__DerivativeGenerator__DerivativeGenerator  =
  c_CasADi__DerivativeGenerator__DerivativeGenerator  >>= wrapReturn

-- classy wrapper
{-|
>>  CasADi::DerivativeGenerator::DerivativeGenerator()
>------------------------------------------------------------------------
>
>Default constructor.
>
>>  CasADi::DerivativeGenerator::DerivativeGenerator(DerivativeGeneratorCPtr ptr)
>------------------------------------------------------------------------
>
>Construct from C pointer.
-}
derivativeGenerator :: IO DerivativeGenerator
derivativeGenerator = casADi__DerivativeGenerator__DerivativeGenerator

