{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.ExpMX
       (
         ExpMX,
         ExpMXClass(..),
         expMX___ge__,
         expMX___gt__,
         expMX___mldivide__,
         expMX___radd__,
         expMX___rdiv__,
         expMX___req__,
         expMX___rge__,
         expMX___rgt__,
         expMX___rle__,
         expMX___rlt__,
         expMX___rmul__,
         expMX___rne__,
         expMX___rsub__,
         expMX___rtruediv__,
         expMX___truediv__,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____mldivide__" c_CasADi__GenericExpression_CasADi__MX_____mldivide__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____mldivide__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____mldivide__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____mldivide__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Matrix division from left.
-}
expMX___mldivide__ :: ExpMXClass a => a -> MX -> IO MX
expMX___mldivide__ x = casADi__GenericExpression_CasADi__MX_____mldivide__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____gt__" c_CasADi__GenericExpression_CasADi__MX_____gt__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____gt__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____gt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____gt__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>No need to have both < and >
-}
expMX___gt__ :: ExpMXClass a => a -> MX -> IO MX
expMX___gt__ x = casADi__GenericExpression_CasADi__MX_____gt__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____ge__" c_CasADi__GenericExpression_CasADi__MX_____ge__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____ge__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____ge__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____ge__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>No need to have both <= and >=.
-}
expMX___ge__ :: ExpMXClass a => a -> MX -> IO MX
expMX___ge__ x = casADi__GenericExpression_CasADi__MX_____ge__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____truediv__" c_CasADi__GenericExpression_CasADi__MX_____truediv__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____truediv__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____truediv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____truediv__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Division (with future.division in effect)
-}
expMX___truediv__ :: ExpMXClass a => a -> MX -> IO MX
expMX___truediv__ x = casADi__GenericExpression_CasADi__MX_____truediv__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____radd__" c_CasADi__GenericExpression_CasADi__MX_____radd__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____radd__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____radd__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____radd__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___radd__ :: ExpMXClass a => a -> MX -> IO MX
expMX___radd__ x = casADi__GenericExpression_CasADi__MX_____radd__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rsub__" c_CasADi__GenericExpression_CasADi__MX_____rsub__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rsub__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rsub__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rsub__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rsub__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rsub__ x = casADi__GenericExpression_CasADi__MX_____rsub__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rmul__" c_CasADi__GenericExpression_CasADi__MX_____rmul__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rmul__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rmul__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rmul__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rmul__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rmul__ x = casADi__GenericExpression_CasADi__MX_____rmul__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rdiv__" c_CasADi__GenericExpression_CasADi__MX_____rdiv__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rdiv__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rdiv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rdiv__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rdiv__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rdiv__ x = casADi__GenericExpression_CasADi__MX_____rdiv__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rlt__" c_CasADi__GenericExpression_CasADi__MX_____rlt__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rlt__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rlt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rlt__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rlt__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rlt__ x = casADi__GenericExpression_CasADi__MX_____rlt__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rle__" c_CasADi__GenericExpression_CasADi__MX_____rle__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rle__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rle__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rle__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rle__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rle__ x = casADi__GenericExpression_CasADi__MX_____rle__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rgt__" c_CasADi__GenericExpression_CasADi__MX_____rgt__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rgt__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rgt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rgt__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rgt__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rgt__ x = casADi__GenericExpression_CasADi__MX_____rgt__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rge__" c_CasADi__GenericExpression_CasADi__MX_____rge__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rge__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rge__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rge__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rge__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rge__ x = casADi__GenericExpression_CasADi__MX_____rge__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____req__" c_CasADi__GenericExpression_CasADi__MX_____req__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____req__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____req__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____req__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___req__ :: ExpMXClass a => a -> MX -> IO MX
expMX___req__ x = casADi__GenericExpression_CasADi__MX_____req__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rne__" c_CasADi__GenericExpression_CasADi__MX_____rne__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rne__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rne__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rne__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rne__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rne__ x = casADi__GenericExpression_CasADi__MX_____rne__ (castExpMX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__MX_____rtruediv__" c_CasADi__GenericExpression_CasADi__MX_____rtruediv__
  :: Ptr ExpMX' -> Ptr MX' -> IO (Ptr MX')
casADi__GenericExpression_CasADi__MX_____rtruediv__
  :: ExpMX -> MX -> IO MX
casADi__GenericExpression_CasADi__MX_____rtruediv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__MX_____rtruediv__ x0' x1' >>= wrapReturn

-- classy wrapper
expMX___rtruediv__ :: ExpMXClass a => a -> MX -> IO MX
expMX___rtruediv__ x = casADi__GenericExpression_CasADi__MX_____rtruediv__ (castExpMX x)

