{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.ExpSX
       (
         ExpSX,
         ExpSXClass(..),
         expSX___ge__,
         expSX___gt__,
         expSX___mldivide__,
         expSX___radd__,
         expSX___rdiv__,
         expSX___req__,
         expSX___rge__,
         expSX___rgt__,
         expSX___rle__,
         expSX___rlt__,
         expSX___rmul__,
         expSX___rne__,
         expSX___rsub__,
         expSX___rtruediv__,
         expSX___truediv__,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______mldivide__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______mldivide__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______mldivide__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______mldivide__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______mldivide__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Matrix division from left.
-}
expSX___mldivide__ :: ExpSXClass a => a -> SX -> IO SX
expSX___mldivide__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______mldivide__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______gt__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______gt__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______gt__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______gt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______gt__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>No need to have both < and >
-}
expSX___gt__ :: ExpSXClass a => a -> SX -> IO SX
expSX___gt__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______gt__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______ge__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______ge__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______ge__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______ge__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______ge__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>No need to have both <= and >=.
-}
expSX___ge__ :: ExpSXClass a => a -> SX -> IO SX
expSX___ge__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______ge__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______truediv__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______truediv__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______truediv__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______truediv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______truediv__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Division (with future.division in effect)
-}
expSX___truediv__ :: ExpSXClass a => a -> SX -> IO SX
expSX___truediv__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______truediv__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______radd__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______radd__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______radd__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______radd__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______radd__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___radd__ :: ExpSXClass a => a -> SX -> IO SX
expSX___radd__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______radd__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rsub__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rsub__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rsub__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rsub__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rsub__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rsub__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rsub__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rsub__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rmul__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rmul__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rmul__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rmul__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rmul__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rmul__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rmul__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rmul__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rdiv__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rdiv__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rdiv__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rdiv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rdiv__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rdiv__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rdiv__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rdiv__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rlt__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rlt__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rlt__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rlt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rlt__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rlt__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rlt__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rlt__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rle__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rle__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rle__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rle__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rle__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rle__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rle__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rle__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rgt__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rgt__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rgt__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rgt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rgt__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rgt__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rgt__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rgt__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rge__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rge__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rge__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rge__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rge__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rge__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rge__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rge__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______req__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______req__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______req__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______req__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______req__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___req__ :: ExpSXClass a => a -> SX -> IO SX
expSX___req__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______req__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rne__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rne__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rne__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rne__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rne__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rne__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rne__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rne__ (castExpSX x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rtruediv__" c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rtruediv__
  :: Ptr ExpSX' -> Ptr SX' -> IO (Ptr SX')
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rtruediv__
  :: ExpSX -> SX -> IO SX
casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rtruediv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rtruediv__ x0' x1' >>= wrapReturn

-- classy wrapper
expSX___rtruediv__ :: ExpSXClass a => a -> SX -> IO SX
expSX___rtruediv__ x = casADi__GenericExpression_CasADi__Matrix_CasADi__SXElement______rtruediv__ (castExpSX x)

