{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.ExpSXElement
       (
         ExpSXElement,
         ExpSXElementClass(..),
         expSXElement___ge__,
         expSXElement___gt__,
         expSXElement___mldivide__,
         expSXElement___radd__,
         expSXElement___rdiv__,
         expSXElement___req__,
         expSXElement___rge__,
         expSXElement___rgt__,
         expSXElement___rle__,
         expSXElement___rlt__,
         expSXElement___rmul__,
         expSXElement___rne__,
         expSXElement___rsub__,
         expSXElement___rtruediv__,
         expSXElement___truediv__,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____mldivide__" c_CasADi__GenericExpression_CasADi__SXElement_____mldivide__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____mldivide__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____mldivide__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____mldivide__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Matrix division from left.
-}
expSXElement___mldivide__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___mldivide__ x = casADi__GenericExpression_CasADi__SXElement_____mldivide__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____gt__" c_CasADi__GenericExpression_CasADi__SXElement_____gt__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____gt__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____gt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____gt__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>No need to have both < and >
-}
expSXElement___gt__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___gt__ x = casADi__GenericExpression_CasADi__SXElement_____gt__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____ge__" c_CasADi__GenericExpression_CasADi__SXElement_____ge__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____ge__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____ge__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____ge__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>No need to have both <= and >=.
-}
expSXElement___ge__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___ge__ x = casADi__GenericExpression_CasADi__SXElement_____ge__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____truediv__" c_CasADi__GenericExpression_CasADi__SXElement_____truediv__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____truediv__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____truediv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____truediv__ x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Division (with future.division in effect)
-}
expSXElement___truediv__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___truediv__ x = casADi__GenericExpression_CasADi__SXElement_____truediv__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____radd__" c_CasADi__GenericExpression_CasADi__SXElement_____radd__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____radd__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____radd__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____radd__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___radd__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___radd__ x = casADi__GenericExpression_CasADi__SXElement_____radd__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rsub__" c_CasADi__GenericExpression_CasADi__SXElement_____rsub__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rsub__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rsub__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rsub__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rsub__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rsub__ x = casADi__GenericExpression_CasADi__SXElement_____rsub__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rmul__" c_CasADi__GenericExpression_CasADi__SXElement_____rmul__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rmul__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rmul__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rmul__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rmul__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rmul__ x = casADi__GenericExpression_CasADi__SXElement_____rmul__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rdiv__" c_CasADi__GenericExpression_CasADi__SXElement_____rdiv__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rdiv__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rdiv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rdiv__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rdiv__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rdiv__ x = casADi__GenericExpression_CasADi__SXElement_____rdiv__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rlt__" c_CasADi__GenericExpression_CasADi__SXElement_____rlt__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rlt__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rlt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rlt__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rlt__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rlt__ x = casADi__GenericExpression_CasADi__SXElement_____rlt__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rle__" c_CasADi__GenericExpression_CasADi__SXElement_____rle__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rle__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rle__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rle__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rle__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rle__ x = casADi__GenericExpression_CasADi__SXElement_____rle__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rgt__" c_CasADi__GenericExpression_CasADi__SXElement_____rgt__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rgt__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rgt__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rgt__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rgt__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rgt__ x = casADi__GenericExpression_CasADi__SXElement_____rgt__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rge__" c_CasADi__GenericExpression_CasADi__SXElement_____rge__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rge__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rge__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rge__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rge__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rge__ x = casADi__GenericExpression_CasADi__SXElement_____rge__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____req__" c_CasADi__GenericExpression_CasADi__SXElement_____req__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____req__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____req__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____req__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___req__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___req__ x = casADi__GenericExpression_CasADi__SXElement_____req__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rne__" c_CasADi__GenericExpression_CasADi__SXElement_____rne__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rne__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rne__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rne__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rne__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rne__ x = casADi__GenericExpression_CasADi__SXElement_____rne__ (castExpSXElement x)


-- direct wrapper
foreign import ccall unsafe "CasADi__GenericExpression_CasADi__SXElement_____rtruediv__" c_CasADi__GenericExpression_CasADi__SXElement_____rtruediv__
  :: Ptr ExpSXElement' -> Ptr SXElement' -> IO (Ptr SXElement')
casADi__GenericExpression_CasADi__SXElement_____rtruediv__
  :: ExpSXElement -> SXElement -> IO SXElement
casADi__GenericExpression_CasADi__SXElement_____rtruediv__ x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__GenericExpression_CasADi__SXElement_____rtruediv__ x0' x1' >>= wrapReturn

-- classy wrapper
expSXElement___rtruediv__ :: ExpSXElementClass a => a -> SXElement -> IO SXElement
expSXElement___rtruediv__ x = casADi__GenericExpression_CasADi__SXElement_____rtruediv__ (castExpSXElement x)

