{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.HomotopyNLPSolver
       (
         HomotopyNLPSolver,
         HomotopyNLPSolverClass(..),
         homotopyNLPSolver,
         homotopyNLPSolver_checkNode,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show HomotopyNLPSolver where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__HomotopyNLPSolver__checkNode" c_CasADi__HomotopyNLPSolver__checkNode
  :: Ptr HomotopyNLPSolver' -> IO CInt
casADi__HomotopyNLPSolver__checkNode
  :: HomotopyNLPSolver -> IO Bool
casADi__HomotopyNLPSolver__checkNode x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__HomotopyNLPSolver__checkNode x0' >>= wrapReturn

-- classy wrapper
{-|
>Check if the node is pointing to the right type of object.
-}
homotopyNLPSolver_checkNode :: HomotopyNLPSolverClass a => a -> IO Bool
homotopyNLPSolver_checkNode x = casADi__HomotopyNLPSolver__checkNode (castHomotopyNLPSolver x)


-- direct wrapper
foreign import ccall unsafe "CasADi__HomotopyNLPSolver__HomotopyNLPSolver" c_CasADi__HomotopyNLPSolver__HomotopyNLPSolver
  :: IO (Ptr HomotopyNLPSolver')
casADi__HomotopyNLPSolver__HomotopyNLPSolver
  :: IO HomotopyNLPSolver
casADi__HomotopyNLPSolver__HomotopyNLPSolver  =
  c_CasADi__HomotopyNLPSolver__HomotopyNLPSolver  >>= wrapReturn

-- classy wrapper
{-|
>Default constructor.
-}
homotopyNLPSolver :: IO HomotopyNLPSolver
homotopyNLPSolver = casADi__HomotopyNLPSolver__HomotopyNLPSolver

