{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.ImplicitFixedStepIntegrator
       (
         ImplicitFixedStepIntegrator,
         ImplicitFixedStepIntegratorClass(..),
         implicitFixedStepIntegrator,
         implicitFixedStepIntegrator_checkNode,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show ImplicitFixedStepIntegrator where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__ImplicitFixedStepIntegrator__checkNode" c_CasADi__ImplicitFixedStepIntegrator__checkNode
  :: Ptr ImplicitFixedStepIntegrator' -> IO CInt
casADi__ImplicitFixedStepIntegrator__checkNode
  :: ImplicitFixedStepIntegrator -> IO Bool
casADi__ImplicitFixedStepIntegrator__checkNode x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__ImplicitFixedStepIntegrator__checkNode x0' >>= wrapReturn

-- classy wrapper
{-|
>Check if the node is pointing to the right type of object.
-}
implicitFixedStepIntegrator_checkNode :: ImplicitFixedStepIntegratorClass a => a -> IO Bool
implicitFixedStepIntegrator_checkNode x = casADi__ImplicitFixedStepIntegrator__checkNode (castImplicitFixedStepIntegrator x)


-- direct wrapper
foreign import ccall unsafe "CasADi__ImplicitFixedStepIntegrator__ImplicitFixedStepIntegrator" c_CasADi__ImplicitFixedStepIntegrator__ImplicitFixedStepIntegrator
  :: IO (Ptr ImplicitFixedStepIntegrator')
casADi__ImplicitFixedStepIntegrator__ImplicitFixedStepIntegrator
  :: IO ImplicitFixedStepIntegrator
casADi__ImplicitFixedStepIntegrator__ImplicitFixedStepIntegrator  =
  c_CasADi__ImplicitFixedStepIntegrator__ImplicitFixedStepIntegrator  >>= wrapReturn

-- classy wrapper
{-|
>Default constructor.
-}
implicitFixedStepIntegrator :: IO ImplicitFixedStepIntegrator
implicitFixedStepIntegrator = casADi__ImplicitFixedStepIntegrator__ImplicitFixedStepIntegrator

