{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.Parallelizer
       (
         Parallelizer,
         ParallelizerClass(..),
         parallelizer,
         parallelizer',
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show Parallelizer where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__Parallelizer__Parallelizer" c_CasADi__Parallelizer__Parallelizer
  :: IO (Ptr Parallelizer')
casADi__Parallelizer__Parallelizer
  :: IO Parallelizer
casADi__Parallelizer__Parallelizer  =
  c_CasADi__Parallelizer__Parallelizer  >>= wrapReturn

-- classy wrapper
{-|
>>  CasADi::Parallelizer::Parallelizer()
>------------------------------------------------------------------------
>
>Default constructor.
>
>>  CasADi::Parallelizer::Parallelizer(const std::vector< Function > &funcs)
>------------------------------------------------------------------------
>
>Create a Parallelizer.
-}
parallelizer :: IO Parallelizer
parallelizer = casADi__Parallelizer__Parallelizer


-- direct wrapper
foreign import ccall unsafe "CasADi__Parallelizer__Parallelizer_TIC" c_CasADi__Parallelizer__Parallelizer_TIC
  :: Ptr (CppVec (Ptr Function')) -> IO (Ptr Parallelizer')
casADi__Parallelizer__Parallelizer'
  :: Vector Function -> IO Parallelizer
casADi__Parallelizer__Parallelizer' x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__Parallelizer__Parallelizer_TIC x0' >>= wrapReturn

-- classy wrapper
parallelizer' :: Vector Function -> IO Parallelizer
parallelizer' = casADi__Parallelizer__Parallelizer'

