{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.QCQPStructure
       (
         QCQPStructure,
         QCQPStructureClass(..),
         qcqpStructure,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show QCQPStructure where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__QCQPStructIOSchemeVector_CasADi__Sparsity___QCQPStructure" c_CasADi__QCQPStructIOSchemeVector_CasADi__Sparsity___QCQPStructure
  :: Ptr (CppVec (Ptr Sparsity')) -> IO (Ptr QCQPStructure')
casADi__QCQPStructIOSchemeVector_CasADi__Sparsity___QCQPStructure
  :: Vector Sparsity -> IO QCQPStructure
casADi__QCQPStructIOSchemeVector_CasADi__Sparsity___QCQPStructure x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__QCQPStructIOSchemeVector_CasADi__Sparsity___QCQPStructure x0' >>= wrapReturn

-- classy wrapper
{-|
>[INTERNAL] 
-}
qcqpStructure :: Vector Sparsity -> IO QCQPStructure
qcqpStructure = casADi__QCQPStructIOSchemeVector_CasADi__Sparsity___QCQPStructure

