{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.QPStructure
       (
         QPStructure,
         QPStructureClass(..),
         qpStructure,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show QPStructure where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__QPStructIOSchemeVector_CasADi__Sparsity___QPStructure" c_CasADi__QPStructIOSchemeVector_CasADi__Sparsity___QPStructure
  :: Ptr (CppVec (Ptr Sparsity')) -> IO (Ptr QPStructure')
casADi__QPStructIOSchemeVector_CasADi__Sparsity___QPStructure
  :: Vector Sparsity -> IO QPStructure
casADi__QPStructIOSchemeVector_CasADi__Sparsity___QPStructure x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__QPStructIOSchemeVector_CasADi__Sparsity___QPStructure x0' >>= wrapReturn

-- classy wrapper
{-|
>[INTERNAL] 
-}
qpStructure :: Vector Sparsity -> IO QPStructure
qpStructure = casADi__QPStructIOSchemeVector_CasADi__Sparsity___QPStructure

