{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.SDPStructure
       (
         SDPStructure,
         SDPStructureClass(..),
         sdpStructure,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show SDPStructure where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__SDPStructIOSchemeVector_CasADi__Sparsity___SDPStructure" c_CasADi__SDPStructIOSchemeVector_CasADi__Sparsity___SDPStructure
  :: Ptr (CppVec (Ptr Sparsity')) -> IO (Ptr SDPStructure')
casADi__SDPStructIOSchemeVector_CasADi__Sparsity___SDPStructure
  :: Vector Sparsity -> IO SDPStructure
casADi__SDPStructIOSchemeVector_CasADi__Sparsity___SDPStructure x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__SDPStructIOSchemeVector_CasADi__Sparsity___SDPStructure x0' >>= wrapReturn

-- classy wrapper
{-|
>[INTERNAL] 
-}
sdpStructure :: Vector Sparsity -> IO SDPStructure
sdpStructure = casADi__SDPStructIOSchemeVector_CasADi__Sparsity___SDPStructure

