{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.SDQPStructure
       (
         SDQPStructure,
         SDQPStructureClass(..),
         sdqpStructure,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show SDQPStructure where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__SDQPStructIOSchemeVector_CasADi__Sparsity___SDQPStructure" c_CasADi__SDQPStructIOSchemeVector_CasADi__Sparsity___SDQPStructure
  :: Ptr (CppVec (Ptr Sparsity')) -> IO (Ptr SDQPStructure')
casADi__SDQPStructIOSchemeVector_CasADi__Sparsity___SDQPStructure
  :: Vector Sparsity -> IO SDQPStructure
casADi__SDQPStructIOSchemeVector_CasADi__Sparsity___SDQPStructure x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__SDQPStructIOSchemeVector_CasADi__Sparsity___SDQPStructure x0' >>= wrapReturn

-- classy wrapper
{-|
>[INTERNAL] 
-}
sdqpStructure :: Vector Sparsity -> IO SDQPStructure
sdqpStructure = casADi__SDQPStructIOSchemeVector_CasADi__Sparsity___SDQPStructure

