{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.SOCPStructure
       (
         SOCPStructure,
         SOCPStructureClass(..),
         socpStructure,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show SOCPStructure where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__SOCPStructIOSchemeVector_CasADi__Sparsity___SOCPStructure" c_CasADi__SOCPStructIOSchemeVector_CasADi__Sparsity___SOCPStructure
  :: Ptr (CppVec (Ptr Sparsity')) -> IO (Ptr SOCPStructure')
casADi__SOCPStructIOSchemeVector_CasADi__Sparsity___SOCPStructure
  :: Vector Sparsity -> IO SOCPStructure
casADi__SOCPStructIOSchemeVector_CasADi__Sparsity___SOCPStructure x0 =
  withMarshal x0 $ \x0' ->
  c_CasADi__SOCPStructIOSchemeVector_CasADi__Sparsity___SOCPStructure x0' >>= wrapReturn

-- classy wrapper
{-|
>[INTERNAL] 
-}
socpStructure :: Vector Sparsity -> IO SOCPStructure
socpStructure = casADi__SOCPStructIOSchemeVector_CasADi__Sparsity___SOCPStructure

