{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Wrappers.Classes.SymbolicNLP
       (
         SymbolicNLP,
         SymbolicNLPClass(..),
         symbolicNLP_parseNL,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Ptr ( Ptr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Wrappers.Classes.PrintableObject
import Casadi.Wrappers.CToolsInstances ( )
import Casadi.Wrappers.Data
import Casadi.Wrappers.Enums
import Casadi.MarshalTypes ( CppVec, StdString' ) -- StdOstream'
import Casadi.Marshal ( Marshal(..), withMarshal )
import Casadi.WrapReturn ( WrapReturn(..) )

instance Show SymbolicNLP where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "CasADi__SymbolicNLP__parseNL" c_CasADi__SymbolicNLP__parseNL
  :: Ptr SymbolicNLP' -> Ptr StdString' -> IO ()
casADi__SymbolicNLP__parseNL
  :: SymbolicNLP -> String -> IO ()
casADi__SymbolicNLP__parseNL x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  c_CasADi__SymbolicNLP__parseNL x0' x1' >>= wrapReturn

-- classy wrapper
{-|
>Parse an AMPL och PyOmo NL-file.
-}
symbolicNLP_parseNL :: SymbolicNLPClass a => a -> String -> IO ()
symbolicNLP_parseNL x = casADi__SymbolicNLP__parseNL (castSymbolicNLP x)

